/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.tables.TCoreMissingclass.TCoreMissingclassPath;
import de.ship.db.tables.TCoreMissinglist.TCoreMissinglistPath;
import de.ship.db.tables.TDmMissingcode.TDmMissingcodePath;
import de.ship.db.tables.TDmMissingvalue.TDmMissingvaluePath;
import de.ship.db.tables.records.TCoreMissingvalueRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TCoreMissingvalue extends TableImpl<TCoreMissingvalueRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_core_missingvalue</code>
     */
    public static final TCoreMissingvalue T_CORE_MISSINGVALUE = new TCoreMissingvalue();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TCoreMissingvalueRecord> getRecordType() {
        return TCoreMissingvalueRecord.class;
    }

    /**
     * The column <code>common_dd.t_core_missingvalue.lastchange</code>.
     */
    public final TableField<TCoreMissingvalueRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_core_missingvalue.pk</code>.
     */
    public final TableField<TCoreMissingvalueRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>common_dd.t_core_missingvalue.fk_missinglist</code>.
     */
    public final TableField<TCoreMissingvalueRecord, Integer> FK_MISSINGLIST = createField(DSL.name("fk_missinglist"), SQLDataType.INTEGER.nullable(false), this, "");

    /**
     * The column <code>common_dd.t_core_missingvalue.fk_missingmaster</code>.
     */
    public final TableField<TCoreMissingvalueRecord, Integer> FK_MISSINGMASTER = createField(DSL.name("fk_missingmaster"), SQLDataType.INTEGER.nullable(false), this, "");

    /**
     * The column <code>common_dd.t_core_missingvalue.missingvalue_ecrf</code>.
     * is this a missing used in web application?
     */
    public final TableField<TCoreMissingvalueRecord, Boolean> MISSINGVALUE_ECRF = createField(DSL.name("missingvalue_ecrf"), SQLDataType.BOOLEAN.nullable(false), this, "is this a missing used in web application?");

    /**
     * The column <code>common_dd.t_core_missingvalue.fk_missingclass</code>.
     * euCanSHare missing classification
     */
    public final TableField<TCoreMissingvalueRecord, Integer> FK_MISSINGCLASS = createField(DSL.name("fk_missingclass"), SQLDataType.INTEGER, this, "euCanSHare missing classification");

    /**
     * The column <code>common_dd.t_core_missingvalue.fk_missingclass_qs</code>.
     * qig missing classification
     */
    public final TableField<TCoreMissingvalueRecord, Integer> FK_MISSINGCLASS_QS = createField(DSL.name("fk_missingclass_qs"), SQLDataType.INTEGER, this, "qig missing classification");

    private TCoreMissingvalue(Name alias, Table<TCoreMissingvalueRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TCoreMissingvalue(Name alias, Table<TCoreMissingvalueRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_core_missingvalue</code> table
     * reference
     */
    public TCoreMissingvalue(String alias) {
        this(DSL.name(alias), T_CORE_MISSINGVALUE);
    }

    /**
     * Create an aliased <code>common_dd.t_core_missingvalue</code> table
     * reference
     */
    public TCoreMissingvalue(Name alias) {
        this(alias, T_CORE_MISSINGVALUE);
    }

    /**
     * Create a <code>common_dd.t_core_missingvalue</code> table reference
     */
    public TCoreMissingvalue() {
        this(DSL.name("t_core_missingvalue"), null);
    }

    public <O extends Record> TCoreMissingvalue(Table<O> path, ForeignKey<O, TCoreMissingvalueRecord> childPath, InverseForeignKey<O, TCoreMissingvalueRecord> parentPath) {
        super(path, childPath, parentPath, T_CORE_MISSINGVALUE);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TCoreMissingvaluePath extends TCoreMissingvalue implements Path<TCoreMissingvalueRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TCoreMissingvaluePath(Table<O> path, ForeignKey<O, TCoreMissingvalueRecord> childPath, InverseForeignKey<O, TCoreMissingvalueRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TCoreMissingvaluePath(Name alias, Table<TCoreMissingvalueRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TCoreMissingvaluePath as(String alias) {
            return new TCoreMissingvaluePath(DSL.name(alias), this);
        }

        @Override
        public TCoreMissingvaluePath as(Name alias) {
            return new TCoreMissingvaluePath(alias, this);
        }

        @Override
        public TCoreMissingvaluePath as(Table<?> alias) {
            return new TCoreMissingvaluePath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public Identity<TCoreMissingvalueRecord, Integer> getIdentity() {
        return (Identity<TCoreMissingvalueRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TCoreMissingvalueRecord> getPrimaryKey() {
        return Keys.PK_CORE_MISSINGVALUE;
    }

    @Override
    public List<UniqueKey<TCoreMissingvalueRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.UK_CORE_MISSINGVALUE);
    }

    @Override
    public List<ForeignKey<TCoreMissingvalueRecord, ?>> getReferences() {
        return Arrays.asList(Keys.T_CORE_MISSINGVALUE__FK_MISSINGLIST, Keys.T_CORE_MISSINGVALUE__FK_MISSINGCLASS, Keys.T_CORE_MISSINGVALUE__T_CORE_MISSINGVALUE_FK_MISSINGCLASS_QS_FKEY);
    }

    private transient TCoreMissinglistPath _tCoreMissinglist;

    /**
     * Get the implicit join path to the
     * <code>common_dd.t_core_missinglist</code> table.
     */
    public TCoreMissinglistPath tCoreMissinglist() {
        if (_tCoreMissinglist == null)
            _tCoreMissinglist = new TCoreMissinglistPath(this, Keys.T_CORE_MISSINGVALUE__FK_MISSINGLIST, null);

        return _tCoreMissinglist;
    }

    private transient TCoreMissingclassPath _fkMissingclass;

    /**
     * Get the implicit join path to the
     * <code>common_dd.t_core_missingclass</code> table, via the
     * <code>fk_missingclass</code> key.
     */
    public TCoreMissingclassPath fkMissingclass() {
        if (_fkMissingclass == null)
            _fkMissingclass = new TCoreMissingclassPath(this, Keys.T_CORE_MISSINGVALUE__FK_MISSINGCLASS, null);

        return _fkMissingclass;
    }

    private transient TCoreMissingclassPath _tCoreMissingvalueFkMissingclassQsFkey;

    /**
     * Get the implicit join path to the
     * <code>common_dd.t_core_missingclass</code> table, via the
     * <code>t_core_missingvalue_fk_missingclass_qs_fkey</code> key.
     */
    public TCoreMissingclassPath tCoreMissingvalueFkMissingclassQsFkey() {
        if (_tCoreMissingvalueFkMissingclassQsFkey == null)
            _tCoreMissingvalueFkMissingclassQsFkey = new TCoreMissingclassPath(this, Keys.T_CORE_MISSINGVALUE__T_CORE_MISSINGVALUE_FK_MISSINGCLASS_QS_FKEY, null);

        return _tCoreMissingvalueFkMissingclassQsFkey;
    }

    private transient TDmMissingvaluePath _tDmMissingvalue;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_dm_missingvalue</code> table
     */
    public TDmMissingvaluePath tDmMissingvalue() {
        if (_tDmMissingvalue == null)
            _tDmMissingvalue = new TDmMissingvaluePath(this, null, Keys.T_DM_MISSINGVALUE__FK_DM_MV_MV.getInverseKey());

        return _tDmMissingvalue;
    }

    /**
     * Get the implicit many-to-many join path to the
     * <code>common_dd.t_dm_missingcode</code> table
     */
    public TDmMissingcodePath tDmMissingcode() {
        return tDmMissingvalue().tDmMissingcode();
    }

    @Override
    public TCoreMissingvalue as(String alias) {
        return new TCoreMissingvalue(DSL.name(alias), this);
    }

    @Override
    public TCoreMissingvalue as(Name alias) {
        return new TCoreMissingvalue(alias, this);
    }

    @Override
    public TCoreMissingvalue as(Table<?> alias) {
        return new TCoreMissingvalue(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreMissingvalue rename(String name) {
        return new TCoreMissingvalue(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreMissingvalue rename(Name name) {
        return new TCoreMissingvalue(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreMissingvalue rename(Table<?> name) {
        return new TCoreMissingvalue(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreMissingvalue where(Condition condition) {
        return new TCoreMissingvalue(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreMissingvalue where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreMissingvalue where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreMissingvalue where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreMissingvalue where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreMissingvalue where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreMissingvalue where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreMissingvalue where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreMissingvalue whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreMissingvalue whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
